mod asteroid;
mod fleet;
mod planet;
mod player;
mod ship;

pub use asteroid::AsteroidBuilder;
pub use fleet::FleetBuilder;
pub use planet::PlanetBuilder;
pub use player::PlayerBuilder;
pub use ship::ShipBuilder;

use specs::error::Error as SpecsError;
use thiserror::Error;

#[derive(Debug, Error)]
pub enum Error {
    #[error("Specs Error: {0}")]
    SpecsError(SpecsError),

    #[error("Builder is missing the value '{0}'")]
    MissingValue(&'static str),
}

impl From<SpecsError> for Error {
    fn from(err: SpecsError) -> Self {
        Self::SpecsError(err)
    }
}
