use serde::{Deserialize, Serialize};
use specs::{Component, NullStorage};

use crate::{builder::PlanetBuilder, misc::FlaggedStorage};

#[derive(Clone, Debug, Default, Serialize, Deserialize)]
pub struct Planet {}

/* Planet */

impl Planet {
    pub fn builder() -> PlanetBuilder {
        PlanetBuilder::default()
    }
}

impl Component for Planet {
    type Storage = FlaggedStorage<Self, NullStorage<Self>>;
}
