use glc::{matrix::Angle, vector::Vector2f};

use crate::components::{ShipData, ShipsData};

/// Distance to orbit before ship is handled as "in orbit" in %
pub const SHIP_ORBIT_DISTANCE_MAX: f32 = 1.10;

/// Minimum angle between old and new target position in orbit
pub const SHIP_ORBIT_ANGLE_DELTA_MIN: Angle<f32> = Angle::Deg(5000.0);

/// Random angle between old and new target position in orbit
pub const SHIP_ORBIT_ANGLE_DELTA_RND: Angle<f32> = Angle::Deg(5000.0);

/// Agility of ships inside orbit
pub const SHIP_ORBIT_AGILITY: Angle<f32> = Angle::Deg(90.0);

pub const VECTOR_2F_POS_X: Vector2f = Vector2f::new(1.0, 0.0);

pub const SHIPS_DATA_FIGHTER: ShipsData = ShipsData {
    fighter: ShipData { speed: 120.0 },
    bomber: ShipData { speed: 80.0 },
    transporter: ShipData { speed: 100.0 },
};

pub const SHIPS_DATA_TRADER: ShipsData = ShipsData {
    fighter: ShipData { speed: 100.0 },
    bomber: ShipData { speed: 70.0 },
    transporter: ShipData { speed: 120.0 },
};

pub const SHIPS_DATA_RESEARCHER: ShipsData = ShipsData {
    fighter: ShipData { speed: 90.0 },
    bomber: ShipData { speed: 60.0 },
    transporter: ShipData { speed: 100.0 },
};
